/* icode.c
	P. Chongstitvatana
	since R1						27 Aug 97
	start project RZ				3 Apr 2001
	project A1						22 Oct 2002
	project Som						13 Sept 2003
	code generator som-c			2 Jan 2004
*/

#include "compile.h"

#define		PRIVATE		static

extern int CP;			// current code pointer

void decode(int ip, int *code, int *data){
	*code = CS[ip] & 255;
	*data = CS[ip] >> 8;
}

void putcode(int ip, int code, int data){
	CS[ip] = (data << 8) | (code & 255);
}

PRIVATE void pl(FILE *fo, char *s1){
	fprintf(fo,"%s",s1);
}
PRIVATE void pl2(FILE *fo, char *s1, int a){
	fprintf(fo,"%s %d",s1,a);
}

void prCode(FILE *fo, int ip){
	int op, a;
	char *nm, buf[80];
	decode(ip,&op,&a);
	switch(op){
	case icAdd: pl(fo,"Add"); break;
	case icSub: pl(fo,"Sub"); break;
	case icMul: pl(fo,"Mul"); break;
	case icDiv: pl(fo,"Div"); break;
	case icBand: pl(fo,"Band"); break;
	case icBor: pl(fo,"Bor"); break;
	case icBxor: pl(fo,"Bxor"); break;
	case icNot: pl(fo,"Not"); break;
	case icEq: pl(fo,"Eq"); break;
	case icNe: pl(fo,"Ne"); break;
	case icLt: pl(fo,"Lt"); break;
	case icLe: pl(fo,"Le"); break;
	case icGe: pl(fo,"Ge"); break;
	case icGt: pl(fo,"Gt"); break;
	case icShl: pl(fo,"Shl"); break;
	case icShr: pl(fo,"Shr"); break;
	case icMod: pl(fo,"Mod"); break;
	case icLdx: pl(fo,"Ldx"); break;
	case icStx: pl(fo,"Stx"); break;
	case icRet: pl2(fo,"Ret",a); break;
	case icArray: pl(fo,"Array"); break;
	case icEnd: pl(fo,"End"); break;
	case icGet: pl2(fo,"Get",a); break;
	case icPut: pl2(fo,"Put",a); break;
	case icLd: pl2(fo,"Ld",a); break;
	case icSt: pl2(fo,"St",a); break;
	case icJmp: pl2(fo,"Jmp",ip+a); break;
	case icJt: pl2(fo,"Jt",ip+a); break;
	case icJf: pl2(fo,"Jf",ip+a); break;
	case icLit: pl2(fo,"Lit",a); break;
	case icCall: pl2(fo,"Call",a); break;
	case icCallt: pl2(fo,"Callt",a); break;
	case icInc: pl2(fo,"Inc",a); break;
	case icDec: pl2(fo,"Dec",a); break;
	case icSys: pl2(fo,"Sys",a); break;
	case icCase: pl(fo,"Case"); break;
	case icFun: pl2(fo,"Fun",a); break;

	default: pl(fo,"Undef");
	}
}

// output object code to file a.obj
void outCode(void){
	int i;
	FILE *fo;
	fo = fopen("a.obj","w");
	fprintf(fo,"%d %d %d\n",OBJ_SOMv2,1,CP-1);
	for(i=1; i<CP; i++){
		fprintf(fo,"%d ",CS[i]);
		if( (i % 10 ) == 0 ) fprintf(fo,"\n");
	}
	fprintf(fo," 1101 1100\n1 0\n");	// no data
	fclose(fo);
}

// output object code to file a.obj
void outCode2(void){
	int i;
	FILE *fo;
	fo = fopen("a.obj","w");
	fprintf(fo,"%d %d %d\n",OBJ_SOMv2,1,CP-1);
	for(i=1; i<CP; i++){
		fprintf(fo,"%d ",CS[i]);
		if( (i % 10 ) == 0 ) fprintf(fo,"\n");
	}
	fprintf(fo," 1101 1100\n1 0\n");	// no data
	for(i=1; i<CP; i++){
		fprintf(fo,"%d %d ",CS[i]&255,CS[i]>>8);
		if( (i % 10 ) == 0 ) fprintf(fo,"\n");
	}
	fclose(fo);
}
// output listing to file
void showCode(FILE *fo){
	int i;
	for(i=1; i<CP; i++){
		fprintf(fo,"\n  %5d ",i);
		prCode(fo,i);
	}
	fprintf(fo,"\n");
}

/* out code with argument */
void outa( int code, int arg){
	CS[CP] = (arg << 8 ) | (code & 255);
	CP++;
}

