/* interp.c

	reentrant eval for som3j		22 Dec 2004
	som-in-som						30 Dec 2004
	remodularise alu() for somv2x	28 July 2005
	rewrite for sgs olympic 2007    28 Mar 2007
 */

// system area  1 .. MAXSYS-1
//   1..80   tokstring-som

#include "compile.h"
#include "interp.h"

#define		PRIVATE 	static

extern FILE *FI;

int M[MAXMEM];	 		// memory
int *CS = &M[MAXDS];	// code segment
PRIVATE int SS[MAXSS];	// stack segment
PRIVATE	int sp=1,fp=0;	// current state SS

int CS_SOM = 0;			// start CS of SOM, init by load obj
int DP = MAXSYS;		// current free data segment
int CP = 1;				// current code pointer

void error(char *mess, int ip){
	printf("%s at ip %d\n",mess,ip);
	exit(0);
}

// static alloc memory of size a
int xalloc(int a){
	int b;
	b = DP;
	if( DP + a >= MAXDS )
		error("xalloc: out of memory",0);
	DP += a;
	return b;
}

// gets() and put it in M[ads]
void dogets(int ads){
	char buf[256], *c;
	int i;
	c = fgets(buf,256,FI);
	if( c != NULL ){
		for(i=0; buf[i] != 0; i++, ads++)
			M[ads] = (int)buf[i] & 255;
		M[ads] = 0;
	}else{
		M[ads] = EOF_CHAR;
		M[ads+1] = 0;
	}
}

void spy(int ads){
	int i;

	if(ads == 357){
		for(i=370; i<=383; i++)
			printf("%d: %d %d\n",i,CS[i]&255,CS[i]>>8);
		printf("asm finish\n");
		exit(0);
	}

//	if(ads == 209){
//		printf("CH %d\n",M[1000]);
//		exit(0);
//	}
//	if(ads == 356){
//		printf("call asm\n");
//		exit(0);
//	}

}

#define bop(opr)	a = NEXT opr TOS; pop1; TOS = a

// reentrant eval
void eval(int ref){
	int runflag;
	int ip, op, data;	// current instruction
	int a, b, low, hi, var;
	int cnt;

	cnt = 0;
	ip = ref;
	runflag = 1;
    while(runflag ) {
		if(cnt++ > 100000) break;
		op = CS[ip] & 255;
		data = CS[ip] >> 8 ;
//		spy(ip);
		ip++;
		switch(op){
		case icAdd:  bop(+); break;
		case icSub:  bop(-); break;
		case icMul:  bop(*); break;
		case icDiv:  bop(/); break;
		case icBand: bop(&); break;
		case icBor:  bop(|); break;
		case icBxor: bop(^); break;
		case icEq:   bop(==); break;
		case icNe:   bop(!=); break;
		case icLt:   bop(<);  break;
		case icLe:   bop(<=); break;
		case icGe:   bop(>=); break;
		case icGt:   bop(>);  break;
		case icShl:  bop(<<); break;
		case icShr:  bop(>>); break;
		case icMod:  bop(%);  break;

		case icNot:	TOS = TOS == FALSE;	break;
		case icLit:	push(data); break;
		case icLd:	push( M[data]);	break;
		case icSt:	M[data] = TOS; pop1; break;
		case icPut:	a = pop();	SS[fp-data] = a; break;
		case icGet:	push(SS[fp-data]); break;
		case icLdx:
			a = NEXT + TOS;
			pop1;
			TOS = M[a];
			break;
		case icStx:
			a = pop();
			b = NEXT + TOS;
			pop2;
			M[b] = a;
			break;
		case icArray:
			a = pop();
			push(xalloc(a));
			break;
		case icJmp:	ip += data-1; break;
		case icJf:
			a = pop();
			if( a == FALSE) ip += data-1;
			break;
		case icJt:
			a = pop();
			if( a != FALSE) ip += data-1;
			break;
		case icCall:
			var = CS[data] >> 8;		// get lv
			if (sp + var + FUDGE > MAXSS)
				error("stack overflow",ip);
			SS[sp+var] = fp;
			fp = sp + var;
			sp = fp + 1;
			SS[sp] = ip;	// ret ads
			ip = data + 1;
			break;
		case icRet:
		// return TOS if stack is not empty
			ip = SS[fp+1];
			if ( sp > fp+1 ){
				a = TOS;
				sp = fp - data + 1;
				fp = SS[fp];
				SS[sp] = a;
			}else{
				sp = fp - data;
				fp = SS[fp];
			}
			break;
		case icInc:	SS[fp-data]++; break;
		case icDec:	SS[fp-data]--; break;
		case icCase:
			low = CS[ip+1] >> 8;
			hi = CS[ip+2] >> 8;
			a = pop();
			if( a < low || a > hi )
				ip += 2;
			else
				ip += a-low+3;
			break;
		case icSys:
			switch(data){
			case 1: 			// print int
				a = pop();
				printf("%d",a);
				break;
			case 2: 			// print char
				a = pop();
				printf("%c",a);
				break;
			case 3: 			// get char
				push(fgetc(FI));
				break;
			case 4:			    // gets()
			    a = pop();		    // som buffer
				dogets(a);
				break;
			case 5:				// eval ref
				a = pop();
				CS = &M[CS_SOM];// switch to user space
				eval(a);
				CS = &M[MAXDS];	// switch back
				break;
			case 7:
				runflag = 0;	// end
				break;
			default: error("undefined syscall",ip);
			}
			break;
		case icEnd:
			runflag = 0;
			break;
		default:
			printf("op %d\n",op);
			error("undefined opcode",ip);
		}
		// end swich(op)
    } // end while runflag
//	printf("noi %d\n",cnt);
}


