/* som.c
	P. Chongstitvatana

	start Som project   			13 Sept 2003
	som3-i   no immediate			20 Dec 2004
	som-in-som						30 Dec 2004
	som-v2x  for p-som				15 July 2005
*/

#include "compile.h"

#define		PRIVATE 	static
#define 	sCP		100				// CP to som
#define		sCS		101				// base of CS to som

extern int CS_SOM, CP;

FILE *FI, *FO;

int readM(int *mem, FILE *fi){
	int i, b, e, c;
	fscanf(fi,"%d%d",&b,&e);
	for(i=b; i<=e; i++){
		fscanf(fi,"%d",&c);
		mem[i] = c;
	}
	return e;
}

int readM2(int *mem, FILE *fi){
	int op, arg, i;
	i = 1;
	fscanf(fi,"%d",&op);
	while( op != 0 ){
		fscanf(fi,"%d",&arg);
		mem[i] = (arg << 8 ) | op;
		i++;
		fscanf(fi,"%d ",&op);
	}
	return i;
}

// read obj from fi into memory
void loadobj(FILE *fi){
	int a;
//	fscanf(fi,"%d",&a);
//	if( a != OBJ_SOMv2 )
//		error("not a som-v2 object",0);
	a = readM2(CS,fi); 	// code
	CP = a;
//	a = readM(M,fi);	// string constant, data
//	DP = a + 1;
    DP = 2000;
}
/*
// load som1 obj
void loadboot(char *fn){
	FILE *fi;
	char buf[80], *c;
	int i, n, a;
	fi = fopen(fn,"r");			// somv1 obj
	fscanf(fi,"%d\n",&n);
	for(i=0; i<n; i++)			// symbol table
	   c = fgets(buf,80,fi);
  	fscanf(fi,"%d",&n);
	for(i=1; i<=n; i++){		// s-code
	   fscanf(fi,"%d",&a);
	   CS[i] = a;
	}
   	CP = n + 1;
//	DP = n + 1;
	fclose(fi);
}

// load first image
void loadboot2(void){			// get s-code from FI
	int i, n, op, arg;
	fscanf(FI,"%d",&n);
	for(i=1; i<=n; i++){
		fscanf(FI,"%d %d",&op,&arg);
		CS[i] = (arg << 8) | op;
	}
	arg = fgetc(FI);			// last nl
	CP = n + 1;
	M[sCP] = CP;				// som CP
	M[sCS] = MAXDS;				// base of som CS
	DP = 1006;					// from first image
}
*/
// format (op arg)* .. terminate by 0
void loadboot2(void){			// get s-code from FI
	int op, arg;
	CP = 1;
	fscanf(FI,"%d",&op);
	while( op != 0 ){
		fscanf(FI,"%d",&arg);
		outa(op,arg);
		fscanf(FI,"%d",&op);
	}
	arg = fgetc(FI);			// last nl
	M[sCP] = CP;				// som CP
	M[sCS] = MAXDS;				// base of som CS
	DP = 1100;					// spare 1000..1100
	printf("CP = %d\n",CP);
}

void Usage(void){
	printf("%s\n%s\n%s\n%s\n",
		"somv2x   file          compile, output a.obj",
		"somv2x -x  obj         run from obj",
		"somv2x -b  file 		boot from file",
		"somv2x -l  obj > lst   produce lst",
		"somv2x -?              for this help");
	exit(0);
}

int main( int argc, char *argv[] ){
	int i, mode;
	char source[80];
	FILE *fin;
	mode = 0;
	for (i=1; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case '?': Usage(); break;
			case 'b': mode = 1; break;
			case 'l': mode = 2; break;
			case 'x': mode = 3; break;
			default: Usage();
			}
		}else
			break;   // first non option
	}
	if(mode != 0){
		strcpy(source,argv[i]);
//		printf("%s\n",source);
		FI = fopen(source,"r");
	}else
		FI = stdin;
	switch(mode){
//	case 0:	loadSom(); eval(1);	break;
//	case 1:	loadSom(); eval(doObj);	break;
/*
	case 0:					// no flag
		DP = 1100;
		psom();
		fclose(FI);
		showCode(stdout);
		outCode2();
		break;
	case 1:					// -b
		loadboot2();
		eval(1);
		fclose(FI);
		CP = M[1002];
 		showCode(stdout);
		break;
*/
	case 2:					// -l
		loadobj(FI);
		fclose(FI);
		showCode(stdout);
		break;
	case 0:					// execute s-object
		loadobj(FI);
		printf("CP = %d DP = %d\n",CP,DP);
		eval(1);
		break;
	}
	return 0;
}
